﻿//-------------------------------------------------------------------------------------
// All Rights Reserved , Copyright (C) 2011 , Hairihan TECH, Ltd. 
//-------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.Remoting;
using System.Reflection;

namespace DotNet.WinForm.BusinessCard
{
    using DotNet.Model;
    using DotNet.Utilities;
    using DotNet.Service;
    using DotNet.WinForm.Utilities;

    /// <summary>
    /// Program
    /// 
    /// 修改纪录
    ///
    ///		2008.11.07 版本：1.0 JiRiGaLa 创建。
    ///		
    /// 版本：1.0
    ///
    /// <author>
    ///		<name>JiRiGaLa</name>
    ///		<date>2008.11.07</date>
    /// </author> 
    /// </summary>
    static class Program
    {

        /// <summary>
        /// 应用程序的主入口点。
        /// </summary>
        [STAThread]
        static void Main()
        {
            // 从配置文件读取数据表的设定
            // TableConfigHelper.Instance.GetConfig(Application.StartupPath + "\\SqlMap\\Common\\BasePermissionTable.xml", new BasePermissionTable());
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            // 是否检查在线状态
            BaseSystemInfo.CheckOnLine = false;
            // 是否记录日志
            BaseSystemInfo.RecordLog = true;
            // BaseSystemInfo.IPAddress = BaseSystemInfo.GetIPAddress();
            // BaseSystemInfo.MACAddress = BaseSystemInfo.GetMacAddress();
            BaseSystemInfo.StartupPath = Application.StartupPath;
            // BaseUserConfig.Instance.LogOnTo = "Access";
            BaseSystemInfo.AppIco = Application.StartupPath + "/Resource/App.ico";

            // 主应用程序集名
            BaseSystemInfo.MainAssembly = System.Reflection.Assembly.GetEntryAssembly().GetName().Name;

            // 读取配置文件
            BaseSystemInfo.ConfigurationFrom = ConfigurationCategory.UserConfig;
            UserConfigHelper.GetConfig();

            // 多语言国际化加载
            ResourceManagerWrapper.Instance.LoadResources(Application.StartupPath + @"\Resource\Localization\");
            // 从当前指定的语言包读取信息
            AppMessage.GetLanguageResource();

            // 分级管理，按什么来计算，是否按编号计算子节点
            // BasePermissionScopeManager.GetChildrensByCode = true;

            Program.InitService(BaseSystemInfo.UserInfo);
            Application.Run(new FrmBusinessCardAdmin());
        }

        #region public static void InitService(BaseUserInfo userInfo) 加载服务
        /// <summary>
        /// 多线程加载服务
        /// </summary>
        public static void InitService(BaseUserInfo userInfo)
        {
            // 加载内部部门
            ClientCache.Instance.DTOrganize = null;
        }
        #endregion
    }
}